
C  ****************************************************************************
C  *                                                                          *
C  *                 *****     SUBROUTINE FILL_PARAMS     *****               *
C  *                                                                          *
C  *    FILL UP THE PARAMETER ARRAYS BY READING DATA IN FROM ALL PARAMETER    *
C  *     FILES (UNIT = 2).                                                    *
C  *                                                                          *
C  *    FEBRUARY 1998 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.       *
C  *    LAST MODIFIED 26-MAY-1998 BY RWA/TSB (Bug in NN variable).            *
C  ****************************************************************************
C
      SUBROUTINE FILL_PARAMS (MODE, NFILES, NIDS_TOT, NIDS, FIDS, 
     1 IDS, TS, PS, OS, XS, YS, MAGS, PFT_CCS, PRJ_CCS, CMP_CCS, 
     2 PARAM_FNAMES)
C      
      IMPLICIT NONE
C
      INTEGER*4 MODE, ID, NFILES, NIDS_TOT, FILE, NN, NIDS(999)
      INTEGER*4 FIDS(NIDS_TOT), IDS(NIDS_TOT), IDS_TOT
      REAL*4    TS(NIDS_TOT), PS(NIDS_TOT), OS(NIDS_TOT)
      REAL*4    XS(NIDS_TOT), YS(NIDS_TOT), MAGS(NIDS_TOT)
      REAL*4    PFT_CCS(NIDS_TOT), PRJ_CCS(NIDS_TOT), CMP_CCS(NIDS_TOT)
      CHARACTER(len=256) PARAM_FNAMES(999)
C  ----------------------------------------------------------------------------
C
      IF(IABS(MODE).EQ.1) THEN      ! GLOBAL MODE: USES ALL IMAGES IN FILES
        IDS_TOT = 0
        DO FILE = 1, NFILES
          DO ID = 1,NIDS(FILE)
            IDS_TOT       = IDS_TOT + 1
            IDS(IDS_TOT)  = ID
            FIDS(IDS_TOT) = FILE
          ENDDO
        ENDDO
        RETURN
      ENDIF
C
      NN = 1
C  *************************************************************
C  * Loop through PARAMETER files and retrieve particle info   *
C  *************************************************************
      DO 900 FILE = 1,NFILES
        NN = NN -1                   ! Needed to handle EOF on 2nd PARAM file
        IF(FILE.GT.1) CLOSE (UNIT=2)
        OPEN (UNIT=2, FILE=PARAM_FNAMES(FILE), STATUS='OLD', ERR=996,
     1      ACCESS='SEQUENTIAL', FORM='FORMATTED', ACTION='READ') !RSSXXX
        READ (2,'(A)',ERR=997)                         ! DUMMY READ #1
        READ (2,'(A)',ERR=998)                        ! DUMMY READ #2
  100        NN = NN + 1
C        IF(NN.GT.NIDS_TOT) GO TO 900 !RSS
        IF(NN.GT.NIDS_TOT) CYCLE !RSS Replace obsolete goto with CYCLE
C     Replacing '(I,9F)' with * - don't need formatted input !RSS
        READ (2,*,END=900,ERR=999) IDS(NN), TS(NN), PS(NN), !RSS
     1  OS(NN), XS(NN), YS(NN), MAGS(NN), PFT_CCS(NN), PRJ_CCS(NN),
     2  CMP_CCS(NN)
        FIDS(NN) = FILE
        GO TO 100
  900      ENDDO
      NN = NN -1
       RETURN
C
  996      PRINT *, '***********************************'
      PRINT *, '* ERROR trying to OPEN PARAM file *'
      CALL TSBEND
 997  PRINT *, '****************************************************'
      PRINT *, '* FILL_PARAMS ERROR reading 1st line of PARAM file *'
      CALL TSBEND
 998  PRINT *, '****************************************************'
      PRINT *, '* FILL_PARAMS ERROR reading 2nd line of PARAM file *'
      CALL TSBEND
 999  PRINT *, '**************************************************'
      PRINT *, '* FILL_PARAMS ERROR reading data from PARAM file *'
      CALL TSBEND
      END
